class PortalCatalog:
    """
    The PortalCatalog interface is the same as the ZCatalog interface,
    with the additional requirement that it must take into account who
    is making the request, and return only results which the user is
    permitted to know about.

    The interface is stable.  The additional requirements beyond what
    ZCatalog provides are implemented by PortalCatalog.  For more
    information, see ZCatalog.
    """

    def searchResults(self, REQUEST=None, used=None, query_map='elided', **kw):
        """
        This is a wrapper around ZCatalog's searchResults method.  It
        examines the REQUEST variable, and if appropreate inserts or
        modifies search keys to ensure that only results the user is
        permitted to know about are returned.  It ensures that the
        user has the 'View' permission on the objects that each result
        represent.  It also hides any future-dated results from users
        not permitted to see them.

        Returns: a list of results
        Permissions: None assigned
        """
