class VirtualHost:
    """
    This interface provides the same virtual hosting as the Site
    Access product.  It is rumoured to be implemented by the
    PortalObject class.  I have never tested nor even examined this
    implementation.
    """

    def manage_editSiteBase(self, base='', path='', REQUEST=None):
        """
        Set the site base and the site path.

        Returns: HTML if REQUEST is not None
        Permissions: None assigned
        """

    def __bobo_traverse__(self, REQUEST, name=None):
        """
        When a site object is traversed, it should reset the
        REQUESTs URL base.  The exception is when the environment
        variable SERVER_URL does not match the new base, in this case, 
        no rewriting should be done (otherwise, your object may become 
        unreachable if your virtual hosts stop working)

        Returns: named object if possible, notFoundError otherwise
        Permissions: None assigned
        """

    def absolute_url(self, relative=None):
        """
        since absolute_url now recurses up the containment
        heirarchy, we want to return an empty string to indicate that
        the recursion should stop here because we are the virtual root 
        for this site object

        Returns: string
        Permissions: None assigned
        """
