import Globals
from Globals import HTMLFile, HTML
from Acquisition import Implicit

from Products.PTKBase.PortalContent import PortalContent
from Discussions import Discussable

def addDocument(self, id, title, description, text_format, text, RESPONSE=None):
    """
    Add a Document
    """
    o=Document()
    o.id=id
    o.title=title
    o.description=description
    o.text=text
    o.text_format=text_format
    o._parse()
    self._setObject(id,o)
    if RESPONSE is not None:
        RESPONSE.redirect(self.absolute_url()+'/portal_contents')
    
class Document(Implicit, PortalContent, Discussable):
    """
    A Document
    """

    meta_type='Document'

    __ac_permissions__=(
        ('View', ('', 'index_html')),
        ('View management screens',('editForm',)),
        ('Change Documents', ('edit',), ('Owner','Manager')),
        )

    index_html=HTMLFile('dtml/documentView', globals())

    editForm=HTMLFile('dtml/documentEdit',globals())

    def edit(self, title, description, text_format, text, file='', REQUEST=None):
        """
        Edit the Document
        """
        self.title=title
        self.description=description
        self.text=text
        if file:
            if type(file) is not type(''):
                file=file.read()
                if file:
                    self.text=file
        self.text_format=text_format
        self._parse()
        self.getPortal().notify_content(
            self, self.getPortal().getAuthenticatedMember())
        if REQUEST is not None:
            return self.editForm(self, REQUEST,
                                 portal_status_message='Document changed.')

    def _parse(self):
        if self.text_format=='structured-text':
            self.cooked_text=self._format_text(self)
        else:
            self.cooked_text=self.text
            
    _format_text=HTML("""<dtml-var text fmt="structured-text">""")

    def SearchableText(self):
        "text for indexing"
        return "%s %s %s" % (self.title, self.description, self.text)

    def Description(self):
        "description for indexing"
        return self.description

    def toolbox_actions(self, url=0):
        if url==0: url=self.absolute_url()
        return (
            {'name':'Edit',
             'url':  url + '/editForm',
             'permissions':('Change Documents',),
             'category':'object',
             },
            )

    ## FTP handlers

    def PUT(self, REQUEST, RESPONSE):
        """Handle HTTP (and presumably FTP?) PUT requests"""
        try:
            self.dav__init(REQUEST, RESPONSE)
            body=REQUEST.get('BODY', '')
            self.edit(self.title, self.description, self.text_format, body)
            RESPONSE.setStatus(204)
            return RESPONSE
        except:
            import traceback
            traceback.print_exc()
            raise

    def manage_FTPget(self):
        "Get the document body for FTP download"
        return self.text

Globals.default__class_init__( Document )

from Products.PTKBase.register import registerPortalContent

registerPortalContent( Document
                     , constructors=( addDocument, )
                     , action='Wizards/Document'
                     , icon=Globals.ImageFile( "document.gif", globals() )
                     )
