import Globals
from Globals import HTMLFile, HTML
from Products.PTKBase.PortalContent import PortalContent
from Discussions import Discussable
from Acquisition import Implicit

def addLink(self, id, title, remote_url, text, RESPONSE=None):
    """
    Add a Link
    """
    o=Link()
    o.id=id
    o.title=title
    o.text=text
    o.remote_url=remote_url
    o._parse()
    self._setObject(id,o)
    if RESPONSE is not None:
        RESPONSE.redirect(self.absolute_url()+'/portal_contents')
        
class Link(Implicit, PortalContent, Discussable):
    """
    A Link
    """

    meta_type='Link'

    __ac_permissions__=(
        ('View', ('', 'index_html')),
        ('View management screens',('editForm',)),
        ('Change Links', ('edit',), ('Owner','Manager')),
        )

    index_html=HTMLFile('dtml/linkView', globals())

    editForm=HTMLFile('dtml/linkEdit',globals())

    def edit(self, title, remote_url, text, REQUEST=None):
        """
        Edit the Link
        """
        self.title=title
        self.text=text
        self.remote_url=remote_url
        self._parse()
        self.getPortal().notify_content(
            self, self.getPortal().getAuthenticatedMember())
        if REQUEST is not None:
            return self.editForm(self, REQUEST,
                                 portal_status_message='Link changed.')

    _format_text=HTML("""<dtml-var text fmt="structured-text">""")

    def _parse(self):
        self.cooked_text=self._format_text(self) 

    def SearchableText(self):
        "text for indexing"
        return "%s %s" % (self.title, self.text)

    def Description(self):
        "description for indexing"
        return self.text

    def toolbox_actions(self, url=0):
        if url==0: url=self.absolute_url()
        return (
            {'name':'Edit',
             'url': url + '/editForm',
             'permissions': ('Change Links',),
             'category':'object',
             },
            )

Globals.default__class_init__( Link )

from Products.PTKBase.register import registerPortalContent
registerPortalContent( Link
                     , constructors=( addLink, )
                     , action='Wizards/Link'
                     , icon=Globals.ImageFile( "link.gif", globals() )
                     )
